searchData={"content_type":"text/markdown","items":[{"doc":"This module represents the SDP Session.\n\nIts fields directly correspond to those defined in\n[RFC4566](https://tools.ietf.org/html/rfc4566#section-5)","ref":"ExSDP.html","title":"ExSDP","type":"module"},{"doc":"","ref":"ExSDP.html#add_attribute/2","title":"ExSDP.add_attribute/2","type":"function"},{"doc":"","ref":"ExSDP.html#add_attributes/2","title":"ExSDP.add_attributes/2","type":"function"},{"doc":"","ref":"ExSDP.html#add_media/2","title":"ExSDP.add_media/2","type":"function"},{"doc":"","ref":"ExSDP.html#get_attribute/2","title":"ExSDP.get_attribute/2","type":"function"},{"doc":"","ref":"ExSDP.html#get_attributes/2","title":"ExSDP.get_attributes/2","type":"function"},{"doc":"Returns new sdp struct.\n\nBy default:\n* `version` is `0`\n* `username`, `session_id`, `session_version` and `address` - refer to `Origin.new/1`\n* `session_name` is `-`","ref":"ExSDP.html#new/1","title":"ExSDP.new/1","type":"function"},{"doc":"","ref":"ExSDP.html#parse/1","title":"ExSDP.parse/1","type":"function"},{"doc":"","ref":"ExSDP.html#parse!/1","title":"ExSDP.parse!/1","type":"function"},{"doc":"","ref":"ExSDP.html#t:t/0","title":"ExSDP.t/0","type":"type"},{"doc":"Module representing address used in connection-data and origin.","ref":"ExSDP.Address.html","title":"ExSDP.Address","type":"module"},{"doc":"","ref":"ExSDP.Address.html#get_addrtype/1","title":"ExSDP.Address.get_addrtype/1","type":"function"},{"doc":"","ref":"ExSDP.Address.html#parse_address/1","title":"ExSDP.Address.parse_address/1","type":"function"},{"doc":"","ref":"ExSDP.Address.html#parse_addrtype/1","title":"ExSDP.Address.parse_addrtype/1","type":"function"},{"doc":"","ref":"ExSDP.Address.html#serialize_address/1","title":"ExSDP.Address.serialize_address/1","type":"function"},{"doc":"","ref":"ExSDP.Address.html#t:fqdn/0","title":"ExSDP.Address.fqdn/0","type":"type"},{"doc":"","ref":"ExSDP.Address.html#t:t/0","title":"ExSDP.Address.t/0","type":"type"},{"doc":"This module represents Attributes fields of SDP.","ref":"ExSDP.Attribute.html","title":"ExSDP.Attribute","type":"module"},{"doc":"Parses SDP Attribute line.\n\n`line` is a string in form of `a=attribute` or `a=attribute:value`.\n`opts` is a keyword list that can contain some information for parsers.\n\nUnknown attributes keys are returned as strings, known ones as atoms.\nFor known attributes please refer to `t()`.","ref":"ExSDP.Attribute.html#parse/2","title":"ExSDP.Attribute.parse/2","type":"function"},{"doc":"","ref":"ExSDP.Attribute.html#t:cat/0","title":"ExSDP.Attribute.cat/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:charset/0","title":"ExSDP.Attribute.charset/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:fingerprint/0","title":"ExSDP.Attribute.fingerprint/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:flag_attributes/0","title":"ExSDP.Attribute.flag_attributes/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:framerate/0","title":"ExSDP.Attribute.framerate/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:framerate_value/0","title":"ExSDP.Attribute.framerate_value/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:hash_function/0","title":"ExSDP.Attribute.hash_function/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:ice_options/0","title":"ExSDP.Attribute.ice_options/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:ice_pwd/0","title":"ExSDP.Attribute.ice_pwd/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:ice_ufrag/0","title":"ExSDP.Attribute.ice_ufrag/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:keywds/0","title":"ExSDP.Attribute.keywds/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:lang/0","title":"ExSDP.Attribute.lang/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:maxptime/0","title":"ExSDP.Attribute.maxptime/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:mid/0","title":"ExSDP.Attribute.mid/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:orient/0","title":"ExSDP.Attribute.orient/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:orient_value/0","title":"ExSDP.Attribute.orient_value/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:ptime/0","title":"ExSDP.Attribute.ptime/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:quality/0","title":"ExSDP.Attribute.quality/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:sdplang/0","title":"ExSDP.Attribute.sdplang/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:setup/0","title":"ExSDP.Attribute.setup/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:setup_value/0","title":"ExSDP.Attribute.setup_value/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:t/0","title":"ExSDP.Attribute.t/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:tool/0","title":"ExSDP.Attribute.tool/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:type/0","title":"ExSDP.Attribute.type/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.html#t:type_value/0","title":"ExSDP.Attribute.type_value/0","type":"type"},{"doc":"This module represents extmap (RFC 8285).","ref":"ExSDP.Attribute.Extmap.html","title":"ExSDP.Attribute.Extmap","type":"module"},{"doc":"","ref":"ExSDP.Attribute.Extmap.html#parse/1","title":"ExSDP.Attribute.Extmap.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.Extmap.html#t:attr_key/0","title":"ExSDP.Attribute.Extmap.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.Extmap.html#t:direction/0","title":"ExSDP.Attribute.Extmap.direction/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.Extmap.html#t:extension_id/0","title":"ExSDP.Attribute.Extmap.extension_id/0","type":"type"},{"doc":"Reason of parsing failure.","ref":"ExSDP.Attribute.Extmap.html#t:reason/0","title":"ExSDP.Attribute.Extmap.reason/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.Extmap.html#t:t/0","title":"ExSDP.Attribute.Extmap.t/0","type":"type"},{"doc":"This module represents fmtp (RFC 5576).\n\nParameters for:\n\n* H264 (not all, RFC 6184),\n* H265 (not all, RFC 7798)\n* VP8, VP9, OPUS (RFC 7587)\n* RTX (RFC 4588)\n* FLEXFEC (RFC 8627)\n* Telephone Events (RFC 4733)\n* RED (RFC 2198)\n\nare currently supported.","ref":"ExSDP.Attribute.FMTP.html","title":"ExSDP.Attribute.FMTP","type":"module"},{"doc":"","ref":"ExSDP.Attribute.FMTP.html#parse/1","title":"ExSDP.Attribute.FMTP.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.FMTP.html#t:attr_key/0","title":"ExSDP.Attribute.FMTP.attr_key/0","type":"type"},{"doc":"Reason of parsing failure.","ref":"ExSDP.Attribute.FMTP.html#t:reason/0","title":"ExSDP.Attribute.FMTP.reason/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.FMTP.html#t:t/0","title":"ExSDP.Attribute.FMTP.t/0","type":"type"},{"doc":"This module represents group (RFC 5888).","ref":"ExSDP.Attribute.Group.html","title":"ExSDP.Attribute.Group","type":"module"},{"doc":"","ref":"ExSDP.Attribute.Group.html#parse/1","title":"ExSDP.Attribute.Group.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.Group.html#t:attr_key/0","title":"ExSDP.Attribute.Group.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.Group.html#t:t/0","title":"ExSDP.Attribute.Group.t/0","type":"type"},{"doc":"This module represents msid (RFC 8830).","ref":"ExSDP.Attribute.MSID.html","title":"ExSDP.Attribute.MSID","type":"module"},{"doc":"","ref":"ExSDP.Attribute.MSID.html#new/2","title":"ExSDP.Attribute.MSID.new/2","type":"function"},{"doc":"","ref":"ExSDP.Attribute.MSID.html#parse/1","title":"ExSDP.Attribute.MSID.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.MSID.html#t:attr_key/0","title":"ExSDP.Attribute.MSID.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.MSID.html#t:t/0","title":"ExSDP.Attribute.MSID.t/0","type":"type"},{"doc":"This module describes what kind(s) of RTCP Feedback will be used (RFC 4585).\n\nThe example lines that are parsed by this module are (`a=rtcp-fb:` prefix will be handled by `ExSDP.Attribute`)\n\n    a=rtcp-fb:* nack\n    a=rtcp-fb:96 goog-remb\n    a=rtcp-fb:96 transport-cc\n    a=rtcp-fb:96 ccm fir\n    a=rtcp-fb:96 nack\n    a=rtcp-fb:96 nack pli","ref":"ExSDP.Attribute.RTCPFeedback.html","title":"ExSDP.Attribute.RTCPFeedback","type":"module"},{"doc":"","ref":"ExSDP.Attribute.RTCPFeedback.html#parse/1","title":"ExSDP.Attribute.RTCPFeedback.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Attribute.RTCPFeedback.html#serialize_feedback_type/1","title":"ExSDP.Attribute.RTCPFeedback.serialize_feedback_type/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.RTCPFeedback.html#t:attr_key/0","title":"ExSDP.Attribute.RTCPFeedback.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.RTCPFeedback.html#t:feedback_type_t/0","title":"ExSDP.Attribute.RTCPFeedback.feedback_type_t/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.RTCPFeedback.html#t:t/0","title":"ExSDP.Attribute.RTCPFeedback.t/0","type":"type"},{"doc":"This module represents RTP mapping, a media-level attribute named `rtpmap`.\n\nThis attribute is defined in [Chapter 6.6 of RFC8866 (SDP)](https://datatracker.ietf.org/doc/html/rfc8866#section-6.6)","ref":"ExSDP.Attribute.RTPMapping.html","title":"ExSDP.Attribute.RTPMapping","type":"module"},{"doc":"","ref":"ExSDP.Attribute.RTPMapping.html#parse/2","title":"ExSDP.Attribute.RTPMapping.parse/2","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.RTPMapping.html#t:attr_key/0","title":"ExSDP.Attribute.RTPMapping.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.RTPMapping.html#t:payload_type_t/0","title":"ExSDP.Attribute.RTPMapping.payload_type_t/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.RTPMapping.html#t:t/0","title":"ExSDP.Attribute.RTPMapping.t/0","type":"type"},{"doc":"This module represents ssrc (RFC 5576).","ref":"ExSDP.Attribute.SSRC.html","title":"ExSDP.Attribute.SSRC","type":"module"},{"doc":"","ref":"ExSDP.Attribute.SSRC.html#parse/1","title":"ExSDP.Attribute.SSRC.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.SSRC.html#t:attr_key/0","title":"ExSDP.Attribute.SSRC.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.SSRC.html#t:t/0","title":"ExSDP.Attribute.SSRC.t/0","type":"type"},{"doc":"This module represents `ssrc-group` [RFC 5576](https://datatracker.ietf.org/doc/html/rfc5576#section-4.2) attribute.","ref":"ExSDP.Attribute.SSRCGroup.html","title":"ExSDP.Attribute.SSRCGroup","type":"module"},{"doc":"","ref":"ExSDP.Attribute.SSRCGroup.html#parse/1","title":"ExSDP.Attribute.SSRCGroup.parse/1","type":"function"},{"doc":"Key that can be used for searching this attribute using `ExSDP.Media.get_attribute/2`.","ref":"ExSDP.Attribute.SSRCGroup.html#t:attr_key/0","title":"ExSDP.Attribute.SSRCGroup.attr_key/0","type":"type"},{"doc":"","ref":"ExSDP.Attribute.SSRCGroup.html#t:t/0","title":"ExSDP.Attribute.SSRCGroup.t/0","type":"type"},{"doc":"This module represents the bandwidth, a field of SDP that\ndenotes the proposed bandwidth to be used by the session or media.\n\nFor more details please see [RFC4566 Section 5.8](https://tools.ietf.org/html/rfc4566#section-5.8).","ref":"ExSDP.Bandwidth.html","title":"ExSDP.Bandwidth","type":"module"},{"doc":"","ref":"ExSDP.Bandwidth.html#parse/1","title":"ExSDP.Bandwidth.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Bandwidth.html#t:t/0","title":"ExSDP.Bandwidth.t/0","type":"type"},{"doc":"","ref":"ExSDP.Bandwidth.html#t:type/0","title":"ExSDP.Bandwidth.type/0","type":"type"},{"doc":"This module represents the Connection Information.\n\nThe address can be represented by either:\n - IPv4 address\n - IPv6 address\n - FQDN (Fully Qualified Domain Name)\n\nIn the case of IPv4 and IPv6 multicast addresses there can be more than one\nparsed from single SDP field if it is described using slash notation.\n\nSessions using an IPv4 multicast connection address MUST also have\na time to live (TTL) value present in addition to the multicast\naddress.\n\nFor more details please see [RFC4566 Section 5.7](https://tools.ietf.org/html/rfc4566#section-5.7)","ref":"ExSDP.ConnectionData.html","title":"ExSDP.ConnectionData","type":"module"},{"doc":"","ref":"ExSDP.ConnectionData.html#parse/1","title":"ExSDP.ConnectionData.parse/1","type":"function"},{"doc":"","ref":"ExSDP.ConnectionData.html#t:reason/0","title":"ExSDP.ConnectionData.reason/0","type":"type"},{"doc":"","ref":"ExSDP.ConnectionData.html#t:t/0","title":"ExSDP.ConnectionData.t/0","type":"type"},{"doc":"This module represents the Encryption field of SDP that\nstores encryption key or acquisition method of such key.\n\nSession key should be present IFF the transport medium\nis secure.\n\nFor more details please see [RFC4566 Section 5.12](https://tools.ietf.org/html/rfc4566#section-5.12)","ref":"ExSDP.Encryption.html","title":"ExSDP.Encryption","type":"module"},{"doc":"","ref":"ExSDP.Encryption.html#parse/1","title":"ExSDP.Encryption.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Encryption.html#t:methods/0","title":"ExSDP.Encryption.methods/0","type":"type"},{"doc":"","ref":"ExSDP.Encryption.html#t:t/0","title":"ExSDP.Encryption.t/0","type":"type"},{"doc":"This module represents the Media field of SDP.\n\nFor more details please see [RFC4566 Section 5.14](https://tools.ietf.org/html/rfc4566#section-5.14)","ref":"ExSDP.Media.html","title":"ExSDP.Media","type":"module"},{"doc":"","ref":"ExSDP.Media.html#add_attribute/2","title":"ExSDP.Media.add_attribute/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#add_attributes/2","title":"ExSDP.Media.add_attributes/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#apply_session/2","title":"ExSDP.Media.apply_session/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#get_attribute/2","title":"ExSDP.Media.get_attribute/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#get_attributes/2","title":"ExSDP.Media.get_attributes/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#new/5","title":"ExSDP.Media.new/5","type":"function"},{"doc":"","ref":"ExSDP.Media.html#parse/1","title":"ExSDP.Media.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Media.html#parse_optional/2","title":"ExSDP.Media.parse_optional/2","type":"function"},{"doc":"","ref":"ExSDP.Media.html#t:t/0","title":"ExSDP.Media.t/0","type":"type"},{"doc":"Represents type of media. In [RFC4566](https://tools.ietf.org/html/rfc4566#section-5.14)\nthere are defined \"audio\", \"video\", \"text\", \"application\", and \"message\" types.\n\nKnown types are represented as atoms others are binaries.","ref":"ExSDP.Media.html#t:type/0","title":"ExSDP.Media.type/0","type":"type"},{"doc":"This module represents the Origin field of SDP that represents the originator of the session.\n\nIf the username is set to `-` the originating host does not support the concept of user IDs.\n\nThe username MUST NOT contain spaces.\n\nFor more details please see [RFC4566 Section 5.2](https://tools.ietf.org/html/rfc4566#section-5.2)","ref":"ExSDP.Origin.html","title":"ExSDP.Origin","type":"module"},{"doc":"Increments `session_version` field.\n\nCan be used while sending offer/answer again.","ref":"ExSDP.Origin.html#bump_version/1","title":"ExSDP.Origin.bump_version/1","type":"function"},{"doc":"Returns new origin struct.\n\nBy default:\n* `username` is `-`\n* `session_id` is random 64 bit number\n* `session_version` is `0`\n* `address` is `{127, 0, 0, 1}`","ref":"ExSDP.Origin.html#new/1","title":"ExSDP.Origin.new/1","type":"function"},{"doc":"","ref":"ExSDP.Origin.html#parse/1","title":"ExSDP.Origin.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Origin.html#t:t/0","title":"ExSDP.Origin.t/0","type":"type"},{"doc":"This module is responsible for parsing SDP multimedia session.","ref":"ExSDP.Parser.html","title":"ExSDP.Parser","type":"module"},{"doc":"Parses SDP Multimedia Session.","ref":"ExSDP.Parser.html#parse/1","title":"ExSDP.Parser.parse/1","type":"function"},{"doc":"Parses SDP Multimedia Session raising an exception in case of failure.","ref":"ExSDP.Parser.html#parse!/1","title":"ExSDP.Parser.parse!/1","type":"function"},{"doc":"This module represents the field of SDP that specifies\nrebroadcasts of a session. Works directly in conjunction\nwith timing `t` parameter.\n\n - active_duration - how long session will last\n - repeat_interval - interval of session rebroadcast\n - offsets - offset between scheduled rebroadcast\n\nIf `start_time` of `t` is set to today 3 pm, `active_duration` is set\nto `3h`, `repeat_interval` is set to `14d` and `offsets` are `0 4d`\nthen the session will be rebroadcasted today at 3 pm and on Thursday 3 pm\nevery two week until `end_time` of param `t`.\n\nFor more details please see [RFC4566 Section 5.10](https://tools.ietf.org/html/rfc4566#section-5.10).","ref":"ExSDP.RepeatTimes.html","title":"ExSDP.RepeatTimes","type":"module"},{"doc":"","ref":"ExSDP.RepeatTimes.html#parse/1","title":"ExSDP.RepeatTimes.parse/1","type":"function"},{"doc":"","ref":"ExSDP.RepeatTimes.html#t:reason/0","title":"ExSDP.RepeatTimes.reason/0","type":"type"},{"doc":"","ref":"ExSDP.RepeatTimes.html#t:t/0","title":"ExSDP.RepeatTimes.t/0","type":"type"},{"doc":"Module providing helper functions for serialization.","ref":"ExSDP.Serializer.html","title":"ExSDP.Serializer","type":"module"},{"doc":"Serializes both sdp lines ( = ) and sdp parameters ( = )","ref":"ExSDP.Serializer.html#maybe_serialize/2","title":"ExSDP.Serializer.maybe_serialize/2","type":"function"},{"doc":"","ref":"ExSDP.Serializer.html#maybe_serialize_base64/2","title":"ExSDP.Serializer.maybe_serialize_base64/2","type":"function"},{"doc":"","ref":"ExSDP.Serializer.html#maybe_serialize_hex/2","title":"ExSDP.Serializer.maybe_serialize_hex/2","type":"function"},{"doc":"","ref":"ExSDP.Serializer.html#maybe_serialize_list/2","title":"ExSDP.Serializer.maybe_serialize_list/2","type":"function"},{"doc":"Module containing sigil for deleting empty lines and replacing `\n` with `\r\n`.","ref":"ExSDP.Sigil.html","title":"ExSDP.Sigil","type":"module"},{"doc":"Deletes empty lines and replaces `\n` with `\r\n`","ref":"ExSDP.Sigil.html#sigil_n/2","title":"ExSDP.Sigil.sigil_n/2","type":"function"},{"doc":"This module groups multiple SDP Timezone Correction used\nfor translating base time for rebroadcasts.","ref":"ExSDP.Timezone.html","title":"ExSDP.Timezone","type":"module"},{"doc":"","ref":"ExSDP.Timezone.html#parse/1","title":"ExSDP.Timezone.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Timezone.html#t:t/0","title":"ExSDP.Timezone.t/0","type":"type"},{"doc":"This module represents a single SDP Timezone Correction used\nfor translating base time for rebroadcasts.\n\nFor more details please see [RFC4566 Section 5.11](https://tools.ietf.org/html/rfc4566#section-5.11)","ref":"ExSDP.Timezone.Correction.html","title":"ExSDP.Timezone.Correction","type":"module"},{"doc":"","ref":"ExSDP.Timezone.Correction.html#parse/1","title":"ExSDP.Timezone.Correction.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Timezone.Correction.html#t:t/0","title":"ExSDP.Timezone.Correction.t/0","type":"type"},{"doc":"This module represents the Timing field of SDP that specifies\nthe start and end time of the session.\n\nFor more details please see [RFC4566 Section 5.9](https://tools.ietf.org/html/rfc4566#section-5.9)","ref":"ExSDP.Timing.html","title":"ExSDP.Timing","type":"module"},{"doc":"","ref":"ExSDP.Timing.html#parse/1","title":"ExSDP.Timing.parse/1","type":"function"},{"doc":"","ref":"ExSDP.Timing.html#t:t/0","title":"ExSDP.Timing.t/0","type":"type"},{"doc":"# ExSDP\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_sdp.svg)](https://hex.pm/packages/ex_sdp)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/ex_sdp/)\n[![CircleCI](https://circleci.com/gh/membraneframework/ex_sdp.svg?style=svg)](https://circleci.com/gh/membraneframework/ex_sdp)\n\nParser and serializer for Session Description Protocol. Based on [RFC4566](https://tools.ietf.org/html/rfc4566)","ref":"readme.html","title":"ExSDP","type":"extras"},{"doc":"The package can be installed by adding `ex_sdp` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_sdp, \"~> 0.13.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - ExSDP","type":"extras"},{"doc":"#","ref":"readme.html#usage","title":"Usage - ExSDP","type":"extras"},{"doc":"Parser parses string with `\\r\\n` terminated lines. (although it will also accept records terminated with\na single newline character)\n\n```elixir\n\"\"\"\nv=0\no=jdoe 2890844526 2890842807 IN IP4 10.47.16.5\ns=Very fancy session name\ni=A Seminar on the session description protocol\nu=http://www.example.com/seminars/sdp.pdf\ne=j.doe@example.com (Jane Doe)\np=111 111 111\nc=IN IP4 224.2.17.12/127\nb=AS:256\nt=2873397496 2873404696\nr=604800 3600 0 90000\nr=7d 1h 0 25h\nz=2882844526 -1h 2898848070 0\nk=clear:key\na=recvonly\na=key:value\nm=audio 49170 RTP/AVP 0\ni=Sample media title\nk=prompt\nm=video 51372 RTP/AVP 99\na=rtpmap:99 h263-1998/90000\n\"\"\"\n|> String.replace(\"\\n\", \"\\r\\n\")\n|> ExSDP.parse()\n\n# =>\n{:ok,\n %ExSDP{\n   attributes: [{\"key\", \"value\"}, :recvonly],\n   bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n   connection_data: %ExSDP.ConnectionData{\n     address: {224, 2, 17, 12},\n     address_count: nil,\n     network_type: \"IN\",\n     ttl: 127\n   },\n   email: \"j.doe@example.com (Jane Doe)\",\n   encryption: %ExSDP.Encryption{key: \"key\", method: :clear},\n   media: [\n     %ExSDP.Media{\n       attributes: [],\n       bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n       connection_data: %ExSDP.ConnectionData{\n         address: {224, 2, 17, 12},\n         address_count: nil,\n         network_type: \"IN\",\n         ttl: 127\n       },\n       encryption: %ExSDP.Encryption{key: nil, method: :prompt},\n       fmt: [0],\n       port: 49170,\n       port_count: 1,\n       protocol: \"RTP/AVP\",\n       title: \"Sample media title\",\n       type: :audio\n     },\n     %ExSDP.Media{\n       attributes: [\n         %ExSDP.Attribute.RTPMapping{\n           clock_rate: 90000,\n           encoding: \"h263-1998\",\n           params: nil,\n           payload_type: 99\n         }\n       ],\n       bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n       connection_data: %ExSDP.ConnectionData{\n         address: {224, 2, 17, 12},\n         address_count: nil,\n         network_type: \"IN\",\n         ttl: 127\n       },\n       encryption: %ExSDP.Encryption{key: \"key\", method: :clear},\n       fmt: 'c',\n       port: 51372,\n       port_count: 1,\n       protocol: \"RTP/AVP\",\n       title: nil,\n       type: :video\n     }\n   ],\n   origin: %ExSDP.Origin{\n     address: {10, 47, 16, 5},\n     network_type: \"IN\",\n     session_id: 2890844526,\n     session_version: 2890842807,\n     username: \"jdoe\"\n   },\n   phone_number: \"111 111 111\",\n   session_information: \"A Seminar on the session description protocol\",\n   session_name: \"Very fancy session name\",\n   time_repeats: [\n     %ExSDP.RepeatTimes{\n       active_duration: 3600,\n       offsets: [0, 90000],\n       repeat_interval: 604800\n     },\n     %ExSDP.RepeatTimes{\n       active_duration: 3600,\n       offsets: [0, 90000],\n       repeat_interval: 604800\n     }\n   ],\n   time_zones_adjustments: %ExSDP.Timezone{\n     corrections: [\n       %ExSDP.Timezone.Correction{adjustment_time: 2882844526, offset: -1},\n       %ExSDP.Timezone.Correction{adjustment_time: 2898848070, offset: 0}\n     ]\n   },\n   timing: %ExSDP.Timing{start_time: 2873397496, stop_time: 2873404696},\n   uri: \"http://www.example.com/seminars/sdp.pdf\",\n   version: 0\n }}\n```\n\n#","ref":"readme.html#parser","title":"Parser - ExSDP","type":"extras"},{"doc":"Serializer serializes `ExSDP` struct to a string with `\\r\\n` terminated lines.\n\n```elixir\n%ExSDP{\n   attributes: [{\"key\", \"value\"}, :recvonly],\n   bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n   connection_data: %ExSDP.ConnectionData{\n     address: {224, 2, 17, 12},\n     network_type: \"IN\",\n     ttl: 127\n   },\n   email: \"j.doe@example.com (Jane Doe)\",\n   encryption: %ExSDP.Encryption{key: \"key\", method: :clear},\n   media: [\n     %ExSDP.Media{\n       attributes: [],\n       bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n       connection_data: %ExSDP.ConnectionData{\n         address: {224, 2, 17, 12},\n         network_type: \"IN\",\n         ttl: 127\n       },\n       encryption: %ExSDP.Encryption{method: :prompt},\n       fmt: [0],\n       port: 49170,\n       port_count: 1,\n       protocol: \"RTP/AVP\",\n       title: \"Sample media title\",\n       type: :audio\n     },\n     %ExSDP.Media{\n       attributes: [\n         %ExSDP.Attribute.RTPMapping{\n           clock_rate: 90000,\n           encoding: \"h263-1998\",\n           payload_type: 99\n         }\n       ],\n       bandwidth: [%ExSDP.Bandwidth{bandwidth: 256, type: :AS}],\n       connection_data: %ExSDP.ConnectionData{\n         address: {224, 2, 17, 12},\n         network_type: \"IN\",\n         ttl: 127\n       },\n       encryption: %ExSDP.Encryption{key: \"key\", method: :clear},\n       fmt: 'c',\n       port: 51372,\n       port_count: 1,\n       protocol: \"RTP/AVP\",\n       type: :video\n     }\n   ],\n   origin: %ExSDP.Origin{\n     address: {10, 47, 16, 5},\n     network_type: \"IN\",\n     session_id: 2890844526,\n     session_version: 2890842807,\n     username: \"jdoe\"\n   },\n   phone_number: \"111 111 111\",\n   session_information: \"A Seminar on the session description protocol\",\n   session_name: \"Very fancy session name\",\n   time_repeats: [\n     %ExSDP.RepeatTimes{\n       active_duration: 3600,\n       offsets: [0, 90000],\n       repeat_interval: 604800\n     },\n     %ExSDP.RepeatTimes{\n       active_duration: 3600,\n       offsets: [0, 90000],\n       repeat_interval: 604800\n     }\n   ],\n   time_zones_adjustments: %ExSDP.Timezone{\n     corrections: [\n       %ExSDP.Timezone.Correction{adjustment_time: 2882844526, offset: -1},\n       %ExSDP.Timezone.Correction{adjustment_time: 2898848070, offset: 0}\n     ]\n   },\n   timing: %ExSDP.Timing{start_time: 2873397496, stop_time: 2873404696},\n   uri: \"http://www.example.com/seminars/sdp.pdf\",\n   version: 0\n}\n|> to_string()\n\n# =>\n\"\"\"\nv=0\no=jdoe 2890844526 2890842807 IN IP4 10.47.16.5\ns=Very fancy session name\ni=A Seminar on the session description protocol\nu=http://www.example.com/seminars/sdp.pdf\ne=j.doe@example.com (Jane Doe)\np=111 111 111\nc=IN IP4 224.2.17.12/127\nb=AS:256\nt=2873397496 2873404696\nr=604800 3600 0 90000\nr=604800 3600 0 90000\nz=2882844526 -1h 2898848070 0\nk=clear:key\na=key:value\na=recvonly\nm=audio 49170 RTP/AVP 0\ni=Sample media title\nc=IN IP4 224.2.17.12/127\nb=AS:256\nk=prompt\nm=video 51372 RTP/AVP 99\nc=IN IP4 224.2.17.12/127\nb=AS:256\nk=clear:key\na=rtpmap:99 h263-1998/90000\n\"\"\"\n```","ref":"readme.html#serializer","title":"Serializer - ExSDP","type":"extras"},{"doc":"Copyright 2020, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license","title":"Copyright and License - ExSDP","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2020 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]}